#!/usr/bin/python3

class SingletonMeta(type):
    def __call__(cls, *args, **kwargs):
        if not hasattr(cls, '_instance'):
            cls._instance = super().__call__(*args, **kwargs)
        return cls._instance


if __name__ == '__main__':
    class Singleton(metaclass=SingletonMeta):
        def __init__(self):
            print('Singleton.__init__()')

    s1 = Singleton()
    s2 = Singleton()
    assert s1 is s2
