#!/usr/bin/python3

class SingletonDecorator:
    def __init__(self, cls):
        self.cls = cls
        self.__instance = None

    def __call__(self, *args, **kwargs):
        if not self.__instance:
            self.__instance = self.cls(*args, **kwargs)
        return self.__instance

if __name__ == '__main__':
    @SingletonDecorator
    class Singleton:
        def __init__(self):
            pass

    s1 = Singleton()
    s2 = Singleton()
    assert s1 is s2
